--- asterisk-11.2.0.orig/apps/app_voicemail.c	2013-01-18 05:26:17.000000000 +0400
+++ asterisk-11.2.0/apps/app_voicemail.c	2013-02-27 15:46:03.002583710 +0400
@@ -10629,7 +10629,6 @@
 	/* Found the msg, so play it back */
 
 	make_file(vms->fn, sizeof(vms->fn), vms->curdir, vms->curmsg);
-	make_file(vms->fn, sizeof(vms->fn), vms->curdir, vms->curmsg);
 
 #ifdef IMAP_STORAGE
 	/*IMAP storage stores any prepended message from a forward
@@ -10639,6 +10638,9 @@
 		wait_file(chan, vms, vms->introfn);
 	}
 #endif
+
+	RETRIEVE(vms->curdir, vms->curmsg, vmu->mailbox, vmu->context);
+	
 	if ((wait_file(chan, vms, vms->fn)) < 0) {
 		ast_log(AST_LOG_WARNING, "Playback of message %s failed\n", vms->fn);
 	} else {
@@ -10650,6 +10652,7 @@
 		ast_mutex_unlock(&vms->lock);
 #endif
 	}
+	DISPOSE(vms->curdir, vms->curmsg);
 
 	return 0;
 }
